import numpy as np
from virgotools import ConnectOnline, cm_start_unique, now_gps
import subprocess as sp
from virgotools import cm_lib
import pytest

returncode = 1
result = b''
try:
    result = sp.check_output(cm_lib.CM_COMMAND + ' names', shell=True)
except sp.CalledProcessError:
    returncode = 2

def setup_module():
    cm_start_unique(__name__)


@pytest.mark.skipif(returncode!=1,reason="Cannot reach NameServer")
@pytest.mark.skipif(b'FbmMainUsers' not in result ,reason="FbmMainUsers is not in the list of Cm applications")
def test_connect_online():
    with ConnectOnline('FbmMainUsers', 'V1:INJ_IMC_TRA_DC') as connection:
        for i in range(3):
            frame = connection.get_next_frame()
            assert abs(frame.gps - now_gps()) < 10

            x = frame.INJ_IMC_TRA_DC
            assert isinstance(x, np.ndarray) and x.size > 1000
            assert np.any(x != 0)
